""" Test the polynomial expansion for a free particle """
from rotagaporp.liouville import q, p, LiouvillePowers

order = 4
ilnq = LiouvillePowers(order, function=q, hamiltonian=p**2/2,
                       recursion='chebyshev', sign=1)
ilnp = LiouvillePowers(order, function=p, hamiltonian=p**2/2,
                       recursion='chebyshev', sign=1)
print(ilnq, ilnp)
print(ilnq.Lf, ilnp.Lf)
